package primes;

import java.util.*; // Vector, Iterator

public class Primes {
	private Vector primes_;

	public Primes() {
		primes_ = new Vector();
		primes_.addElement(new Prime(2));
	}
	
	public String toString() {
		return primes_.toString();
	}
	
	public Vector value() {
		return (Vector) primes_.clone();
	}
	
	public void upTo(int max) {
		int num = this.lastPrime();
		while (num < max) {
			num++;
			if (isPrime(num))
				primes_.addElement(new Prime(num));
		}
	}
	
	public int lastPrime() {
		return ((Prime) primes_.lastElement()).value();
	}
	
	private boolean isPrime(int n) {
		Iterator list = primes_.iterator();
		
		while(list.hasNext()) {
			Prime prime = (Prime) list.next();
			if (prime.squareBigger(n))
				return true;
			if (prime.divides(n))
				return false;
		}
		return false;
	}
}
